<cfscript>
	import algorithms.Utils;
	import algorithms.merging.MergeAlgorithms;
	
	Utils = new Utils();
	MergeAlgorithms = new MergeAlgorithms();
	
	// Note: We need sorted arrays, otherwise the concept of "Merged"
	// is difficult to define.
	
	arraySize = 5000;
	
	a = Utils.randArray(size=arraySize,sorted=true);
	b = Utils.randArray(size=arraySize,sorted=true);
	
	Utils.demoStart("MergeArraysSort() Numbers");
	list = MergeAlgorithms.mergeArraysSort(a,b,"numeric");
	Utils.demoEnd([a,b,list]);
	
	a = Utils.randArray(size=arraySize,sorted=true);
	b = Utils.randArray(size=arraySize,sorted=true);
	
	Utils.demoStart("MergeArrays() Numbers");
	list = MergeAlgorithms.mergeArrays(a,b,Utils.numericComparator);
	Utils.demoEnd([a,b,list]);
	
	// Sorted by x asc, y asc
	a = [{x=1,y=2},{x=3,y=2},{x=5,y=0},{x=7,y=6}];
	b = [{x=5,y=5},{x=0,y=6},{x=61,y=2},{x=11,y=3}];
	
	a = Utils.randStructArray(size=arraySize,properties=["x","y"],sorted=true);
	b = Utils.randStructArray(size=arraySize,properties=["x","y"],sorted=true);
		
	Utils.demoStart("MergeArrays() Structs");
	list = MergeAlgorithms.mergeArrays(a,b,Utils.xyStructComparator);
	Utils.demoEnd([a,b,list]);
	
	Utils.demoStart("MergeArraysKeySort()");
	list = MergeAlgorithms.mergeArrayKeySort(a,b,["x","y"]);
	Utils.demoEnd([a,b,list]);
	
	Utils.demoStart("MergeArraysKeySort() Optimized");
	list = MergeAlgorithms.mergeArrayKeySortOptimized(a,b,["x","y"]);
	Utils.demoEnd([a,b,list]);
	
	Utils.demoStart("MergeArraysKeySort() Query");
	list = MergeAlgorithms.mergeArrayKeySortQuery(a,b,["x","y"]);
	Utils.demoEnd([a,b,list]);
			
</cfscript>